
//--------------------------------
// FavManager Client Side Source
//--------------------------------
//
//   version  : for Windows + IE
//   coder    : upride.com
//   update   : 2007/06/07
//   charset  : UTF-8




//--------------------------------
// Global Variable
//--------------------------------

	var linkCount=0;
	var linkArray = [[],[],[],[]]; // grp, icon, title, url
	var dispDlg = true; // Dialog Display Use Flag




//--------------------------------
// Public Function Call List
//--------------------------------
//
//    getFavorites()
//    setAllCheckbox(bool)
//    setRevCheckbox()
//    sendCheck(mode)
//    changeMode(mode)
//    changeViewMode(viewMode)


function getFavorites()
{

	try
	{

		linkCount = 0;
		delete linkArray;

		var objWsh = new ActiveXObject("Wscript.Shell");
		var strFavorites = objWsh.SpecialFolders("Favorites")+'';

		getFavArray(strFavorites,strFavorites);

		delete objFavorites; objFavorites = null;
		delete objWsh; objWsh = null;

		setViewListFromArray();

	}
	catch(e)
	{
		alert("エラーが発生しました\nオブジェクトを生成できません\nブラウザの設定を変更して下さい\n"+e+"");
	}

}


function setAllCheckbox(bool)
{

	for(var i=0; i<document.forms[0].elements.length; i++){
		var chk = document.forms[0].elements[i];
		if(chk.type=="checkbox") chk.checked=bool;
	}

}


function setRevCheckbox()
{

	for(var i=0; i<document.forms[0].elements.length; i++){
		var chk = document.forms[0].elements[i];
		if(chk.type=="checkbox"){
			if(chk.checked) chk.checked=false;
			else chk.checked=true;
		}
	}

}


function sendCheck(mode)
{

	switch(mode)
	{
	case "add":
		if(setSelectArray())
		{
			if(!dispDlg){ document.forms[0].submit(); }
			else{
				if(window.confirm('選択したブックマークをサーバにアップロードします\nよろしいですか？')){
					document.forms[0].submit();
				}
			}
		}
		else{
			alert("ブックマークを選択して下さい");
		}
		break;

	case "edit":
		if(!dispDlg){ document.forms[0].submit(); }
		else{
			if(window.confirm('選択したブックマークを編集します\nよろしいですか？')){
				document.forms[0].submit();
			}
		}
		break;

	case "del":
		if(!dispDlg){ document.forms[0].submit(); }
		else{
			if(window.confirm('選択したブックマークを削除します\nよろしいですか？')){
				document.forms[0].submit();
			}
		}
		break;

	}
	return false;

}


function changeMode(mode)
{

	if(mode!="add"){
		var flg = false;
		var rb = document.forms[0].rb;
		if(!rb) return false;
		if(rb.checked) flg = true;
		for(var i=0; i<rb.length; i++){
			if(rb[i].checked){
				flg = true;
			}
		}
		if(!flg){
			alert("ブックマークを選択して下さい");
			return false;
		}
	}

	var form = document.forms[0];
		var sel = document.createElement("input");
		sel.type = "hidden";
		sel.value = mode;
		sel.name = "sel";
		form.appendChild(sel);

	document.forms[0].submit();

}


function changeViewMode(viewMode)
{

	var form = document.forms[0];
		var view = document.createElement("input");
		view.type = "text";
		view.value = viewMode;
		view.name = "viewmode";
		form.appendChild(view);
	document.forms[0].submit();

}




//--------------------------------
// Private Function
//--------------------------------


function getFavArray(strTargetPath,strRootPath)
{

	var objFso = new ActiveXObject("Scripting.FileSystemObject");
	var objFolder = objFso.GetFolder(addBs(strTargetPath)+"\\");

	for(var objSubFolder = new Enumerator(objFolder.Subfolders); !objSubFolder.atEnd(); objSubFolder.moveNext()) {
		getFavArray(objSubFolder.item()+'', strRootPath);
	}

	for(var objFile = new Enumerator(objFolder.Files); !objFile.atEnd(); objFile.moveNext()) {

		var strTargetFile = objFile.item()+'';
		var objTargetFile = objFso.GetFile(addBs(strTargetFile));
		if (objTargetFile.Type=="インターネット ショートカット"){
			var objText = objTargetFile.OpenAsTextStream(1);
			var strTitle = ""; var strUrl = ""; var strGrp = ""; var strIcon = "IconFile=";
			while(!objText.AtEndOfStream)
			{
				var readText = objText.ReadLine();
				if(readText.toLowerCase() == "[internetshortcut]")
				{
					readText = objText.ReadLine(); //次行であるこの行とは断定できないのだが・・
					if(readText.substr(0,4).toLowerCase() == "url=")
					{
						strUrl = readText;
					}
				}
				else if(readText.substr(0,9).toLowerCase() == "iconfile=")
				{
					strIcon = readText;
				}
			}
			objText.Close();
			delete objText; objText = null;

			if(strUrl!=""){
				strTitle = objFso.GetBaseName(addBs(strTargetFile));
				strGrp = setGroupDir(strTargetFile, objTargetFile.Name, strRootPath);
				linkArray[0][linkCount] = strGrp;
				linkArray[1][linkCount] = strIcon.substr(9,strIcon.length);
				linkArray[2][linkCount] = strTitle;
				linkArray[3][linkCount] = strUrl.substr(4,strUrl.length);
				linkCount++;
			}
		}
		delete objTargetFile; objTargetFile = null;

	}

	delete objEnum; objEnum = null;
	delete objFolder; objShell = objFolder;
	delete objFso; objFso = null;

}


function addBs(strpath)
{

	var ret = strpath.replace(/\\/g,"\\\\");
	return ret;

}


function setGroupDir(strTargetFile, strFileName, strTargetPath)
{

	var strRet = strTargetFile.replace(strTargetPath,"").replace(strFileName,"").replace(/\\/g,"/");
	return strRet;

}


function setViewListFromArray()
{

	var divList = document.getElementById("list");
	var div = document.createElement("div");
		div.className = "linkNowrap";
		var title = "<br>クライアントのブックマーク&nbsp;";
		title += "<a href='javascript:void(0);' onclick='javascript: setAllCheckbox(false);' class='linkNowrap'><small>全解除</small></a>&nbsp;&nbsp;";
		title += "<a href='javascript:void(0);' onclick='javascript: setRevCheckbox();' class='linkNowrap'><small>選択反転</small></a>&nbsp;&nbsp;";
		title += "<a href='javascript:void(0);' onclick=\"javascript: sendCheck('add'); return false;\"><small>選択ブックマークをサーバにアップロード</small></a>";
		title += "<hr>";
		div.innerHTML = title;

		var tbl = document.createElement("table");
			tbl.className = "linkTable";
			var tb = document.createElement("tbody");

				var tr = document.createElement("tr");
					var headerArray = new Array("","グループ","","タイトル","URL");
					for(var i=0; i<5; i++){
						var td = document.createElement("td");
							td.className = "headTitle";
							td.innerHTML = headerArray[i];
						tr.appendChild(td);
					}
				tb.appendChild(tr);

				for(var i=0; i<linkCount; i++){

					var tr = document.createElement("tr");

						var chkTd = document.createElement("td");
							var chk = document.createElement("input");
							chk.type = "checkbox";
							chkTd.appendChild(chk);
						tr.appendChild(chkTd);

						var grpTd = document.createElement("td"); // grp
							grpTd.innerHTML = linkArray[0][i];
						tr.appendChild(grpTd);

						var iconTd = document.createElement("td"); // icon
							if(linkArray[1][i]==""){
								iconTd.innerHTML = "&nbsp;";
							}
							else {
								var img = document.createElement("img");
								iconTd.appendChild(img);
								img.src = linkArray[1][i];
								img.width = 16;
								img.height = 16;
							}
						tr.appendChild(iconTd);

						var titleTd = document.createElement("td"); // title
							titleTd.className = "linkNowrap";
								var titleAncor = document.createElement("a");
								titleAncor.href = linkArray[3][i];
								titleAncor.target = "_blank";
								titleAncor.innerHTML = linkArray[2][i];
							titleTd.appendChild(titleAncor);
						tr.appendChild(titleTd);

						var urlTd = document.createElement("td"); // url
							urlTd.className = "linkNowrap";
								var urlAncor = document.createElement("a");
								urlAncor.href = linkArray[3][i];
								urlAncor.target = "_blank";
								var strAlert = "";
								if(linkArray[3][i].length > 1000) strAlert = "<b>(Over Size:"+ linkArray[3][i].length + ")</b> ";
								if(linkArray[3][i].toLowerCase().substr(0,11)=="javascript:"){
									urlAncor.innerHTML = strAlert + "JavaScript";
								}
								else{
									urlAncor.innerHTML = strAlert + linkArray[3][i];
								}
							urlTd.appendChild(urlAncor);
						tr.appendChild(urlTd);

					tb.appendChild(tr);
				}

			tbl.appendChild(tb);
		div.appendChild(tbl);

		var hidden = document.createElement("input");
			hidden.type = "hidden";
			hidden.name = "favdata";
			hidden.id = "favdata";
		div.appendChild(hidden);

	divList.appendChild(div);

}


function setSelectArray()
{

	var selCount = 0;
	var separator = new Array("grp", "icon", "title", "url", "recordend");
	var strBuf = "";

	for(var i=0; i<document.forms[0].elements.length; i++){
		var chk = document.forms[0].elements[i];
		if((chk.type=="checkbox")&&(chk.checked)){
			selCount++;
			for(var k=0; k<4; k++)
			{
				strBuf += "__" + separator[k] + "__" + linkArray[k][i];
			}
			strBuf += "__" + separator[4] + "__";
		}
	}

	if(selCount>0){
		var hidden = document.getElementById("favdata");
		hidden.value = "";
		hidden.value = strBuf;
		return true;
	}

	return false;

}


