<?php

//--------------------------------
// FavManager Main Source
//--------------------------------
//
//   version  : 
//   coder    : upride.com
//   update   : 2007/06/07
//   charset  : UTF-8



//--------------------------------
// Initialize
//--------------------------------

//include
require_once "init.inc";
ini_set("include_path",ini_get("include_path")); // PEAR INSTALLPATH
require_once "DB.php";  // PEAR::DB

//init
header($PhpHeader);
session_start();
define("DefaultFavImg", "./fav/img/file.gif");

//mode,flg
$from = $_SESSION["from"];
$to = $_SESSION["to"];
$err = $_SESSION["err"];
$_SESSION["err"] = "";
$sel = $_POST["sel"];
$viewmode = $_SESSION["viewmode"];

//postdata
$cltFav = htmlspecialchars($_POST['favdata']);
$key = htmlspecialchars($_POST["rb"]);
$grp = htmlspecialchars($_POST["grp"]);
$icon = htmlspecialchars($_POST["icon"]);
$title = htmlspecialchars($_POST["title"]);
$url = htmlspecialchars($_POST["url"]);
$comment = htmlspecialchars($_POST["comment"]);
$host = htmlspecialchars($_POST["host"]);
$account = htmlspecialchars($_POST["account"]);
$ua = htmlspecialchars($_POST["ua"]);
$selviewmode = $_POST["viewmode"];


//--------------------------------
// Main Function
//--------------------------------

main();
function main()
{

	Global $sel, $viewmode, $selviewmode, $from, $to, $cltFav, $key, $PHP_SELF;

	if($to=="") $to = MainFlg;
	if($from=="") $from = MainFlg;

	if(($sel=="add")||($sel=="edit")||($sel=="del")) $to = $sel;
	else $to = MainFlg;

	switch($to)
	{
	case "add" :
		setHtml("");
		$_SESSION['from'] = "add"; $_SESSION['to'] = MainFlg;
		break;

	case "edit" :
		setHtml(getSelData());
		$_SESSION['from'] = "edit"; $_SESSION['to'] = MainFlg;
		break;

	case "del" :
		setHtml(getSelData());
		$_SESSION['from'] = "del"; $_SESSION['to'] = MainFlg;
		break;

	default :

		if(($from!=MainFlg)&&($to==MainFlg)){
			if(($from=="add")&&($cltFav)){
				getCltFav();
			}
			elseif(($from=="del")&&($key)){
				execDelFav($key);
			}
			elseif(($from=="edit")&&($key)){
				if(!execUpdFav()){
					setHtml(getSelData());
					break;
				}
			}
		}

		if($viewmode=="") $viewmode = DefaultDispMode;
		if($selviewmode!="") $viewmode = $selviewmode;
		$_SESSION["viewmode"] = $viewmode;
		switch($viewmode){
		case "list" :
			setHtml(getSrvFavList());
			break;
		case "tree" :
			setHtml(getSrvFavTree());
			break;
		}
		$_SESSION['from'] = MainFlg; $_SESSION['to'] = "any";

	}

}



//--------------------------------
// Sub Function
//--------------------------------

function convCharFromDb($str)
{
	return mb_convert_encoding($str,DispCharset,DBCharset);
}


function convCharToDb($str)
{
	return mb_convert_encoding($str,DBCharset,DispCharset);
}


function setSize($str,$n)
{
	$size = mb_strlen($str,DispCharset);
	if($size<20) return 20;
	else return $size*$n;
}


function convJs($str)
{
	if(strlen($str)>10){
		if(strtolower(mb_substr($str, 0, 11))=="javascript:"){
			$str="JavaScript";
		}
	}
	return $str;
}


function setIcon($file)
{
	$tag1 = "<img src='"; $tag2="' width=16 height=16 border=0 class='icon'>&nbsp;";
	if($file=="") $file=DefaultFavImg; else $file=convCharFromDb($file);
	return $tag1.$file.$tag2;
}


function setHeader()
{
	echo <<< HTML
<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3.org/TR/html4/loose.dtd'>
<html>
	<head>
		<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
		<link rel='stylesheet' type='text/css' href='./yui/treeview/assets/tree.css'>
		<link rel='stylesheet' type='text/css' href='./fav/css/folders/tree.css'>
		<link rel='stylesheet' type='text/css' href='./fav/css/screen.css'>
		<link rel='stylesheet' type='text/css' href='./fav/css/fav.css'>
		<style>body {margin:10px;}</style>
		<script type='text/javascript' src='./yui/yahoo/yahoo-min.js'></script>
		<script type='text/javascript' src='./yui/event/event-min.js'></script>
		<script type='text/javascript' src='./yui/treeview/treeview-min.js'></script>
		<script type='text/javascript' src='./fav/js/fav.js'></script>
	</head>
	<body>\n
HTML;
}


function setFooter()
{
	echo "\t</body>\n</html>\n";
}


function setHtml($favList)
{

	Global $to, $PHP_SELF;

	$favmanVer = FavmanVer;
	$favmanSupport = FavmanSupport;
	setHeader();

	$link = "<span class='linkNowrap'><a href='$PHP_SELF'>サーバのブックマーク</a></span>&nbsp;&nbsp;"
				. "<span class='linkNowrap'><a href='javascript:void(0);' onclick=\"javascript: changeMode('add'); return false;\">クライアントのブックマーク</a>&nbsp;<small style='color:red'>※ブラウザ警告が出ます</small></span>";

	echo <<< HTML
		<form method='post' action='$PHP_SELF'>
			<div id='menu' class='linkNowrap'>
				<span class='linkNowrap'><b>FavManager</b>&nbsp;</span>
				<span class='linkNowrap'><a class='support' href='$favmanSupport' target='_blank'>ver&nbsp;$favmanVer</a>&nbsp;&nbsp;</span>$link
			</div>
			<div id='list'>$favList
			</div>
		</form>\n
HTML;

	if($to=="add"){
		echo "<script language=javascript> getFavorites(); </script>";
	}

	setFooter();

}


function getSrvFavList()
{

	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;

	$db = DB::connect($dsn);
	if (DB::isError($db)) {
		return "DB接続エラー[".DB::errorMessage($db)."]";
	}

	$sql = "select * from ".TblData." order by upddate desc";
	$res = $db->getAll($sql,Array(),DB_FETCHMODE_ASSOC);
	if (DB::isError($res)) {
		return "レコード取得エラー[".DB::errorMessage($db)."]";
	}

	for($i=0; $i<count($res); $i++){
		$strData .= "<tr>";
		$strData .= "<td><input type='radio' name='rb' value='".$res[$i]["id"]."'></td>";
		$strData .= "<td class='linkNowrap'>".convCharFromDb($res[$i]["grp"])."</td>";
		if($res[$i]["icon"]!=""){
			$strTemp = "<img src='".convCharFromDb($res[$i]["icon"])."' width='16' height='16'>";
		}
		else{
			$strTemp = "&nbsp;";
		}
		$strData .= "<td>".$strTemp."</td>";
		$strData .= "<td class='linkNowrap'><a href=\"".convCharFromDb($res[$i]["url"])."\" target='_blank'>".convCharFromDb($res[$i]["title"])."</a></td>";
		$strData .= "<td class='linkNowrap'><a href=\"".convCharFromDb($res[$i]["url"])."\" target='_blank'>".convCharFromDb(convJs($res[$i]["url"]))."</a></td>";
		$strData .= "<td class='linkNowrap'>".nl2br(convCharFromDb($res[$i]["comment"]))."</td>";
		$strData .= "<td class='linkNowrap'>".convCharFromDb($res[$i]["host"])."</td>";
		$strData .= "<td class='linkNowrap'>".convCharFromDb($res[$i]["account"])."</td>";
		$strData .= "<td class='linkNowrap'>".convCharFromDb($res[$i]["ua"])."</td>";
		$strData .= "<td class='linkNowrap'>".convCharFromDb($res[$i]["upddate"])."</td>";
		$strData .= "</tr>\n";
	}

	$db->disconnect();

	$strRet .= <<< HTML
\n				<div>
					<br>サーバのブックマーク&nbsp;
					<a href='javascript:void(0);' onclick="javascript: changeViewMode('tree');return false;"><small>ツリー表示</small></a>&nbsp;&nbsp;
					<a href='javascript:void(0);' onclick="javascript: changeMode('edit');return false;"><small>編集</small></a>&nbsp;&nbsp;
					<a href='javascript:void(0);' onclick="javascript: changeMode('del');return false;"><small>削除</small></a>&nbsp;&nbsp;
					<hr>

<table>
<tr>
	<td>&nbsp;</td>
	<td class='linkNowrap'>グループ</td>
	<td>&nbsp;</td>
	<td class='linkNowrap'>タイトル</td>
	<td class='linkNowrap'>URL</td>
	<td class='linkNowrap'>コメント</td>
	<td class='linkNowrap'>クライアント</td>
	<td class='linkNowrap'>アカウント</td>
	<td class='linkNowrap'>ユーザエージェント</td>
	<td class='linkNowrap'>更新日時</td>
</tr>
$strData</table>\n
				</div>
HTML;

	return $strRet;

}


function getSrvFavTree()
{

	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;

	$db = DB::connect($dsn);
	if (DB::isError($db)) {
		return "DB接続エラー[".DB::errorMessage($db)."]";
	}

	/* Folders */

	$sql = "Select grp from ".TblData." Where grp != '/' Group By grp Order By grp ";
	$res = $db->getAll($sql,Array(),DB_FETCHMODE_ASSOC);
	if (DB::isError($res)) {
		return "レコード取得エラー[".DB::errorMessage($db)."]";
	}

	for($i=0; $i<count($res); $i++){
		$folderData[$i][0] = convCharFromDb($res[$i]["grp"]);
		$folderData[$i][3] = $res[$i]["grp"];
		$temp = explode("/", $folderData[$i][0]);
		if(count($temp)>2){
			for($j=count($temp)-1; $j>-1; $j--){
				if($temp[$j]!=""){
					$folderData[$i][1] = $temp[$j];
					for($k=0; $k<$j; $k++){
						$folderData[$i][2] .= $temp[$k]."/";
					}
					break;
				}
			}
		}
		else{
			$folderData[$i][1] = implode("", $temp);
			$folderData[$i][2] = "/";
		}
	}

	for($i=0; $i<count($folderData); $i++)
	{
		if($folderData[$i][2]=="/") $parent = "rootNode";
		else{
			for($j=0; $j<count($folderData); $j++){
				if($folderData[$j][0]==$folderData[$i][2]){
					$parent = "folder".$j;
					break;
				}
			}
		}
		$favArrData .= "\t\t\tvar folder".$i." = new YAHOO.widget.TextNode(\"".$folderData[$i][1]."\", ".$parent.", false);\n";
	}
	//$favArrData .= "\t\t\tthisTree.tree.draw();\n";

	/* Files in Folder */

	for($i=0; $i<count($folderData); $i++)
	{
		$sql = "Select title, url, grp ,icon from ".TblData." Where grp = ? Order By title ";
		$res=null;$res = $db->getAll($sql,Array($folderData[$i][3]),DB_FETCHMODE_ASSOC);
		for($j=0; $j<count($res); $j++){
			$img = setIcon($res[$j]["icon"]);
			$favArrData .= "\t\t\tvar file".$i."_".$j." = new YAHOO.widget.TextNode(\"".$img.convCharFromDb($res[$j]["title"])."\", folder".$i.", false);";
			$favArrData .= " file".$i."_".$j.".href = \"".convCharFromDb($res[$j]["url"])."\";";
			$favArrData .= " file".$i."_".$j.".target = \"_blank\";\n";
		}
	}
	$favArrData .= "\t\t\tthisTree.tree.draw();\n";

	/* Files in Root */

	$sql = "Select title, url, grp ,icon from ".TblData." Where grp = ? Order By title ";
	$res=null;$res = $db->getAll($sql,Array("/"),DB_FETCHMODE_ASSOC);
	for($j=0; $j<count($res); $j++){
		$img = setIcon($res[$j]["icon"]);
		$favArrData .= "\t\t\tvar rootFile".$j." = new YAHOO.widget.TextNode(\"".$img.convCharFromDb($res[$j]["title"])."\", rootNode, false);";
		$favArrData .= " rootFile".$j.".href = \"".convCharFromDb($res[$j]["url"])."\";";
		$favArrData .= " rootFile".$j.".target = \"_blank\";\n";
	}
	$favArrData .= "\t\t\tthisTree.tree.draw();\n";

	$db->disconnect();

	$strRet .= <<< HTML
\n				<div>
					<br>サーバのブックマーク&nbsp;
					<a href='javascript:void(0);' onclick="javascript: changeViewMode('list');return false;"><small>リスト表示</small></a>&nbsp;&nbsp;
					<a href='javascript:void(0);' onclick="javascript: thisTree.tree.expandAll(); return false;"><small>全部開く</small></a>&nbsp;&nbsp;
					<a href='javascript:void(0);' onclick="javascript: thisTree.tree.collapseAll(); return false;"><small>全部閉じる</small></a>&nbsp;&nbsp;
					<hr>
					<div id="treeDiv"></div>
				</div>
				<script language='javascript'>

					if(!YAHOO.fav) YAHOO.namespace('fav');
					if(!YAHOO.fav.tree) YAHOO.fav.tree = function(id){ this.tree = new YAHOO.widget.TreeView(id); }

	YAHOO.util.Event.addListener
	( window, "load",
		function(){
			thisTree = new YAHOO.fav.tree('treeDiv');
			var rootNode = thisTree.tree.getRoot();
$favArrData
		}
	);

				</script>\n
HTML;

	return $strRet;

}


function getCltFav()
{

	Global $cltFav;

	$separator = array("grp","icon","title","url");
	$record = explode('__recordend__', $cltFav);
	for($i=0; $i<count($record)-1; $i++)
	{
		$strTemp = $record[$i];
		for($j=3; $j>-1; $j--)
		{
			$strTempArr = explode("__".$separator[$j]."__", $strTemp);
			$linkTempArray[$j] = $strTempArr[1];
			$strTemp = $strTempArr[0];
		}

		$linkArray[$i][0] = $i;
		$linkArray[$i][1] = convCharToDb($linkTempArray[0]);
		$linkArray[$i][2] = convCharToDb($linkTempArray[1]);
		$linkArray[$i][3] = convCharToDb($linkTempArray[2]);
		$linkArray[$i][4] = convCharToDb($linkTempArray[3]);
		$linkArray[$i][5] = "";
		$linkArray[$i][6] = convCharToDb(RemoteHost);
		$linkArray[$i][7] = convCharToDb(UserName);
		$linkArray[$i][8] = UA;
		$linkArray[$i][9] = date('Y-m-d H:i:s',time());
	}
	setCltFav($linkArray);

}


function setCltFav($linkArray)
{

	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;
	$db = DB::connect($dsn);

	$maxid =& $db->getOne("select max(id) as cnt from ".TblData);
	if(PEAR::isError($maxid)){ die(setHtml("<br>"."キー番号取得エラー")); }
	for($i=0; $i<count($linkArray); $i++){ $linkArray[$i][0] = $maxid + 1 + $i; }

	$template = $db->prepare("insert into ".TblData." values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
	$res =& $db->executeMultiple($template, $linkArray);

	if(PEAR::isError($res)){
		die(setHtml("<br>".$res->getMessage()));
	}

	$db->disconnect();

}


function getSelData()
{

	Global $PHP_SELF, $sel, $from, $err, $key, $grp, $icon, $title, $url, $comment, $host, $account, $ua;

	if($sel=="") $sel = $from;
	if(($sel!="edit")&&($sel!="del")){
		return "asd";
		if(!is_numeric($key)) return "選択エラー";
	}

	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;
	$db = DB::connect($dsn);

	$record =& $db->getRow("select * from ".TblData." where id =".$key , array(), DB_FETCHMODE_ORDERED);
	if(PEAR::isError($record)){ return "データ取得エラー"; }

	for($i=0; $i<count($record); $i++){
		$record[$i] = convCharFromDb($record[$i]);
	}

	$db->disconnect();

	$str = "の実行";
	if($sel=="edit"){
		$mode="編集";
		$iconCss = "";
	}
	elseif($sel=="del"){
		$mode="削除";
		$iconCss = " class=icon ";
	}

	if(($sel=="edit")&&($err!="")){
		$record[1] = $grp;
		$record[2] = $icon;
		$record[3] = $title;
		$record[4] = $url;
		$record[5] = $comment;
		$record[6] = $host;
		$record[7] = $account;
		$record[8] = $ua;
	}

	if($record[2]!=""){
		$strIcon = "<img width=16 height=16 ".$iconCss."src='".$record[2]."'>&nbsp;";
	}

	if($sel=="edit"){
		$record[1] = "<input type=text value=\"".$record[1]."\" name=grp size=".setSize($record[1],1)." maxlength=100>";
		$record[2] = "<input type=text value=\"".$record[2]."\" name=icon size=".setSize($record[2],1)." maxlength=255>";
		$record[3] = "<input type=text value=\"".$record[3]."\" name=title size=".setSize($record[3],2)." maxlength=255>";
		$record[4] = "<input type=text value=\"".$record[4]."\" name=url size=".setSize($record[4],1)." maxlength=1000>";
		$record[5] = "<textarea name=comment cols=50>".$record[5]."</textarea>";
		$record[6] = "<input type=text value=\"".$record[6]."\" name=host size=".setSize($record[6],1)." maxlength=50>";
		$record[7] = "<input type=text value=\"".$record[7]."\" name=account size=".setSize($record[7],1)." maxlength=50>";
		$record[8] = "<input type=text value=\"".$record[8]."\" name=ua size=".setSize($record[8],1)." maxlength=255>";
	}
	elseif($sel=="del"){
		$record[5] = nl2br($record[5]);
	}

	if($sel=="edit") $strAsta = "&nbsp;<small>*</small>&nbsp;&nbsp;";
	elseif($sel=="del") $strAsta = "&nbsp;&nbsp;";

	$strRet .= <<< HTML
\n<div>
<br>ブックマークの$mode&nbsp;
<a href='javascript:void(0);' onclick="javascript: sendCheck('$sel'); return false;"><small>$mode$str</small></a>&nbsp;&nbsp;
<a href='$PHP_SELF'><small>戻&nbsp;る</small></a>&nbsp;&nbsp;
<hr>
<table>
<tr><td>&nbsp;</td><td class='err'>$err&nbsp;</td></tr>
<tr><td class='linkNowrap'>グループ$strAsta</td><td class='linkNowrap'>$record[1]&nbsp;</td></tr>
<tr><td class='linkNowrap'>アイコン</td><td class='linkNowrap'>$record[2]&nbsp;$strIcon</td></tr>
<tr><td class='linkNowrap'>タイトル$strAsta</td><td class='linkNowrap'>$record[3]&nbsp;</td></tr>
<tr><td class='linkNowrap'>URL$strAsta</td><td class='linkNowrap'>$record[4]&nbsp;</td></tr>
<tr><td class='linkNowrap'>コメント</td><td class='linkNowrap'>$record[5]&nbsp;</td></tr>
<tr><td class='linkNowrap'>クライアント$strAsta</td><td class='linkNowrap'>$record[6]&nbsp;</td></tr>
<tr><td class='linkNowrap'>アカウント$strAsta</td><td class='linkNowrap'>$record[7]&nbsp;</td></tr>
<tr><td class='linkNowrap'>ユーザエージェント$strAsta</td><td class='linkNowrap'>$record[8]&nbsp;</td></tr>
<tr><td class='linkNowrap'>更新日時&nbsp;</td><td class='linkNowrap'>$record[9]&nbsp;</td></tr>
</table>
<input type=hidden value='$key' name=rb>
</div>\n
HTML;

	return $strRet;

}


function execDelFav($key)
{

	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;
	$db = DB::connect($dsn);

	$template = $db->prepare("delete from ".TblData." where id = ?");
	$res =& $db->execute($template, $key);

	if(PEAR::isError($res)){
		die(setHtml("<br>".$res->getMessage()));
	}

	$db->disconnect();

}


function execUpdFav()
{

	Global $key, $grp, $icon, $title, $url, $comment, $host, $account, $ua;

	if(($grp=="")||($title=="")||($url=="")||($host=="")||($account=="")||($ua=="")){
		$_SESSION["err"] = "空白の項目があります";
		return false;
	}
/*	if(preg_match("/'/",$grp)){
		$_SESSION["err"] = "シングルクォートは使用できません";
		return false;
	}
*/
	$dsn = ObjectDriver."://".DBUser.":".DBPassword."@".DBHost."/".Database;
	$db = DB::connect($dsn);

	$sql  = "update ".TblData." set grp=?, icon=?, title=?, url=?, comment=?, host=?, account=?, ua=?, upddate=? where id=? ";

	$data = array(
		convCharToDb($grp),
		convCharToDb($icon),
		convCharToDb($title),
		convCharToDb($url),
		convCharToDb($comment),
		convCharToDb($host),
		convCharToDb($account),
		convCharToDb($ua),
		date('Y-m-d H:i:s',time()),
		$key
	);

	$template = $db->prepare($sql);
	$res =& $db->execute($template, $data);

	if(PEAR::isError($res)){
		die(setHtml("<br>".$res->getMessage()));
		return false;
	}

	$db->disconnect();

	return true;

}


?>
